/******************************************
 **              CSR UTILS               **
 ** http://www.dcsr.ru/comp/csrutils/    **
 ******************************************
 **                 File                 **
 **          [Internal header]           **
 ** Version 1.0 (2015 DECEMBER 04)       **
 ******************************************/

#pragma once

#ifdef __linux__
#include <dirent.h>
#endif

#ifdef _WIN32
#include <windows.h>
#endif

namespace csrutils {

class FileBaseDisk;
class FileIteratorBaseDisk;

//struct FileBaseDisk_Ctx;

class FileBaseDisk : public csrutils::FileBase {
//	FileBaseDisk_Ctx* ctx;
	FileType b_type;
	StringB b_path;
#ifndef _WIN32
	StringAB u_path;
#endif

public:
	FileBaseDisk(String path);
	FileBaseDisk(const FileBaseDisk& base);
	~FileBaseDisk();

	bool getexists();
	FileType gettype();
	uint64_t getsize();
	FileMD5 md5();

	FileIteratorBase* getfiles();
	FileBase* getchild(String path);
	StringB getname();
	void info(FILE_INFO&);
	FileHandle* open(uint32_t flags);
	Url getpath();
	FileBase* getfile(const Url& path);
	
	bool remove();
	bool createdir();

	FileBase* clone();

	//inline String getpath() const { return b_path; }

	friend class FileIteratorBaseDisk;
};

class FileIteratorBaseDisk : public FileIteratorBase {
#ifdef _WIN32
	HANDLE hFind;
	WIN32_FIND_DATAW findData;
	bool found;
#else
	DIR *dp;
#endif
	FileBaseDisk* dir;

public:
	FileIteratorBaseDisk(FileBase* directory);
	~FileIteratorBaseDisk();

	FileBase* getnext();
	void begin();

	friend class FileBaseDisk;
};

};
