/******************************************
 **              CSR UTILS               **
 ** http://www.dcsr.ru/comp/csrutils/    **
 ******************************************
 **             Image utils              **
 ******************************************/

#include <csrutils.h>
#include <csrimage.h>

namespace csrutils {

struct ImageToolSet {
	void* info;
	void* data;
	bool (*create)(ImageToolSet* data);
	bool (*destroy)(ImageToolSet* data);
};

bool image_gettoolset(ImageToolSet *toolset, int width, int height, ImageBitFormat fmt);

class Image2 {
	int width;
	int height;
	ImageBitFormat fmt;
	ImageToolSet toolset;

public:
	inline Image2(int _width, int _height, ImageBitFormat _fmt)
			: width(_width), height(_height), fmt(_fmt) {
		if( !image_gettoolset(&toolset,width,height,fmt) )
			throw 0;
		if( toolset.create(&toolset) )
			throw 0;
	}

	inline ~Image2() {
		toolset.destroy(&toolset);
	}
};

};