/******************************************
 **              CSR UTILS               **
 ** http://www.dcsr.ru/comp/csrutils/    **
 ******************************************
 **         Multithreading utils         **
 ** SyncObject linux implementation      **
 ** Version: 0.1 (2015-08-09)            **
 ******************************************/

#include <pthread.h>

#include <csrmthread.h>

using namespace csrutils;

struct csrutils::SyncObject_Ctx {
	volatile size_t counter;
	pthread_mutex_t mutex;
};

SyncObject::SyncObject() {
	ctx = new SyncObject_Ctx;
	ctx->counter = 0;
	//InitializeCriticalSection(&ctx->mutex);
}

SyncObject::~SyncObject() {
	//DeleteCriticalSection(&ctx->mutex);
}

void SyncObject::uses_inc() {
	//InterlockedIncrement(&ctx->counter);
	//ctx->counter ++;
	__sync_add_and_fetch(&ctx->counter,1);
}

bool SyncObject::uses_dec() {
	//InterlockedDecrement(&ctx->counter);
	//ctx->counter --;
	__sync_sub_and_fetch(&ctx->counter,1);
	return ctx->counter == 0;
}

size_t SyncObject::uses() {
	return ctx->counter;
}

void SyncObject::lock() {
	//EnterCriticalSection(&ctx->mutex);
	pthread_mutex_lock(&ctx->mutex);
}

void SyncObject::unlock() {
	//LeaveCriticalSection(&ctx->mutex);
	pthread_mutex_unlock(&ctx->mutex);
}
