/******************************************
 **              CSR UTILS               **
 ** http://www.dcsr.ru/comp/csrutils/    **
 ******************************************
 **              OS Utils                **
 ******************************************/

#pragma once

#include <csrstr.h>

struct OS_FILE;

bool os_fopen(OS_FILE **file, const char *path, int flags);
bool os_fclose(OS_FILE *file);
bool os_fread(OS_FILE *file, void *buffer, size_t &size);
bool os_fwrite(OS_FILE *file, const void *buffer, size_t &size);

bool os_fmap(OS_FILE *file, size_t size, void **data);
bool os_funmap(OS_FILE *file, size_t size, void **data);

void* os_virtualalloc(size_t size);
void os_virtualfree(void* ref, size_t size);

char *os_convertencoding1(const wchar_t* str, csrutils::StringEncoding encoding);
wchar_t *os_convertencoding2(const char* str, csrutils::StringEncoding encoding);
