#pragma once

#include "csrutils.h"
#include "csrmthread.h"

namespace csrutils {

class ThreadManager;

typedef bool (*TManager_Proc_Init)(void *ctx, ThreadManager *mng);
typedef bool (*TManager_Proc_Deinit)(void *ctx, ThreadManager *mng);
typedef bool (*TManager_Proc_Proc)(void *ctx, ThreadManager *mng, void *data);

enum TManager_Proc_Flags {
    TMP_ThreadRigid = 0x0002
};
//DEFINE_ENUM_FLAG_OPERATORS(OBJMON_FLAGS)
CSRUTILS_DEFINE_ENUM_FLAG_OPERATORS(TManager_Proc_Flags)

struct TManager_Proc {
	uint64_t uid;
	TManager_Proc_Init procInit;
	TManager_Proc_Deinit procDeinit;
};

struct ThreadManager_Ctx;
class ThreadManager {
	ThreadManager_Ctx *ctx;
public:
	ThreadManager();

	bool RegProc(TManager_Proc proc);
	bool GetProc(TManager_Proc &proc, uint64_t uid);
};

}
