#include <sys/stat.h> 
#include <sys/mman.h>
#include <fcntl.h>
#include <iconv.h>
#include <string.h>
#include <wchar.h>

#include "csrutils.h"
#include "csrosutils.h"
#include "csrmem.h"
#include "csrstr.h"

using namespace csrutils;

struct OS_FILE {
	int fd;
};

bool os_fopen(OS_FILE **file, const char *path, int flags) {
	// TODO:
	return true;
}

inline const char* get_os_encoding(StringEncoding encoding) {
	switch(encoding) {
	case STRING_UTF8:
		return "UTF-8";
	case STRING_CP1251:
		return "CP1251";
	default:
		return "CP1251";
	}
}

char *os_convertencoding1(const wchar_t* str, StringEncoding encoding) {
	const char* encname = get_os_encoding(encoding);
	iconv_t enc = iconv_open(encname,"WCHAR_T");
	size_t sz = wcslen(str);
	char *buf = new char[3*sz+1];
	char *inbuf = (char*) str;
	char *outbuf = buf;
	size_t inbytesleft  = sizeof(wchar_t)*sz;
	size_t outbytesleft = 3*sz;
	iconv(enc,&inbuf,&inbytesleft,&outbuf,&outbytesleft);
	outbuf[0] = '\0';
	return buf;
}

wchar_t *os_convertencoding2(const char* str, StringEncoding encoding) {
	const char* encname = get_os_encoding(encoding);
	iconv_t enc = iconv_open("WCHAR_T",encname);
	size_t sz = strlen(str);
	wchar_t *buf = new wchar_t[sz+1];
	char *inbuf = (char*) str;
	char *outbuf = (char*) buf;
	size_t inbytesleft  = sz;
	size_t outbytesleft = sizeof(wchar_t)*sz;
	iconv(enc,&inbuf,&inbytesleft,&outbuf,&outbytesleft);
	outbuf[0] = '\0';
	outbuf[1] = '\0';
	return buf;
}

void* os_virtualalloc(size_t size) {
	return mmap(NULL,size,PROT_READ|PROT_WRITE,MAP_ANONYMOUS|MAP_PRIVATE,-1,0);
}

void os_virtualfree(void* ref, size_t size) {
	munmap(ref,size);
}


