#include <string.h>
#include <malloc.h>

#include "csrutils.h"
#include "csrstr.h"

using namespace csrutils;

StringBuffer::StringBuffer() {
	buffer   = 0;
	capacity = 0;
	size     = 0;
}

StringBuffer::~StringBuffer() {
	free( buffer );
}

StringBuffer::operator StringB() {
	buffer[size] = '\0';
	return StringB(buffer);
}

bool StringBuffer::append(wchar_t ch) {
	wchar_t bf[2];
	bf[0] = (char) ch;
	bf[1] = '\0';
	return append(bf);
}

bool StringBuffer::append(String str) {
	return append( str.bytes() );
}

bool StringBuffer::append(const wchar_t *str) {
	size_t len = wcslen(str);
	if( capacity < size + len ) {
		size_t sz = capacity * 2;
		if( sz < len )
			sz = ( ((len-1)>>12) + 1 ) << 12;
		buffer = (wchar_t*) realloc(buffer,sz);
		capacity = sz;
	}
	memcpy(buffer+size,str,2*len);
	size += len;
	return true;
}


size_t StringBuffer::length() {
	return size;
}

wchar_t *StringBuffer::getdata() {
	return buffer;
}

void StringBuffer::copy(wchar_t *buffer) {
	memcpy(buffer,this->buffer,2*size);
}