/******************************************
 **              CSR UTILS               **
 ** http://info.dcsr.ru/comp/csrutils/   **
 ******************************************
 **              XML utils               **
 **   Version: 0.0 (2015-00-00)          **
 ******************************************/

#pragma once

#include "csrutils.h"
#include "csrstream.h"

namespace csrutils {

enum XmlTokenType {
	XML_OPENTAG,
	XML_CLOSETAG,
	XML_TEXT
};

class XmlReader;
class XmlToken;

class XmlToken {
public:
	XmlReader *reader;
	XmlTokenType type;
	bool closed;
	char *text;
	int nparam;
	char **pars;
	char **vals;

	XmlToken() { };
	~XmlToken();

	char *getValue(const char *key);
};

struct XmlReaderCtx;

class XmlReader {
	XmlReaderCtx *ctx;
	IOStream &input;

public:
	XmlReader(IOStream &input);
	~XmlReader();

	XmlToken *getToken();
};

};
