/******************************************
 **              CSR UTILS               **
 ** http://info.dcsr.ru/comp/csrutils/   **
 ******************************************
 **         ZIP-archive utils            **
 ** Version: 0.0 (2015-00-00)            **
 ******************************************/

#pragma once

#include <csrutils.h>
#include <csrstream.h>
#include <csrfile.h>

#include <string>
#include <vector>

namespace csrutils {

enum ZipArchiveMode {
	ZIP_READ,
	ZIP_NEW,
	ZIP_EDIT,
	ZIP_MAP
};

class ZipArchive;
class ZipArchiveEntryHandle;

struct ZipArchiveEntryHandle_Ctx;
class ZipArchiveEntryHandle : public FileHandle {
	//friend ZipArchive;

	ZipArchiveEntryHandle_Ctx *ctx;
	ZipArchive *zip;
	size_t offset;

public:
	//std::string path;
	//unsigned long size;
	//bool opened;

	ZipArchiveEntryHandle(const File& file, uint32_t flags);
	~ZipArchiveEntryHandle();

	int read(void *data, size_t size, size_t& read);
	int write(const void *data, size_t size, size_t& written);

	uint64_t getsize();
	uint64_t getposition();
	bool setposition(uint64_t pos);
	bool setend() { return false; }
};

struct ZipArchive_Ctx;
class ZipArchive {
	//friend ZipArchiveEntry;
#ifdef _CSR_INTERNAL_
public:
#endif
	ZipArchive_Ctx *ctx;

public:
	ZipArchive(File file, ZipArchiveMode mode);
	~ZipArchive();

	File root();
	File file(String path);

	//bool open(const char *file, ZipArchiveMode mode);
	//bool close();

	//bool writeFile(const char *name, const void *data, long size);
	//bool addFile(const char *extname, const char *intname);

	//ZipArchiveEntry *addEntry(std::string path);
	//ZipArchiveEntry *getEntry(std::string path);
};

}